CBC_MAC< T > Class Template Reference

CBC-MAC. More...

`#include <cbcmac.h>`

Inheritance diagram for CBC_MAC< T >:

## Public Member Functions

| CBC_MAC ()
| Construct a CBC_MAC.
| CBC_MAC (const byte *key, size_t length=SameKeyLengthAs< T >::DEFAULT_KEYLENGTH)
| Construct a CBC_MAC.
Public Member Functions inherited from AlgorithmImpl< SimpleKeyingInterfaceImpl< CBC_MAC_Base, CBC_MAC< T > >, CBC_MAC< T > >
std::string | AlgorithmName () const
| The algorithm name.
Public Member Functions inherited from SimpleKeyingInterfaceImpl< CBC_MAC_Base, CBC_MAC< T > >
size_t | MinKeyLength () const
| The minimum key length used by the algorithm.
size_t | MaxKeyLength () const
| The maximum key length used by the algorithm.
size_t | DefaultKeyLength () const
| The default key length used by the algorithm.
size_t | GetValidKeyLength (size_t keylength) const
| Provides a valid key length for the algorithm.
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| The default IV requirements for the algorithm.
unsigned int | IVSize () const
| The initialization vector length for the algorithm.
Public Member Functions inherited from CBC_MAC_Base
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | TruncatedFinal (byte *mac, size_t size)
| Computes the hash of the current message.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
virtual void | Restart ()
| Restart the hash.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from AlgorithmImpl< SimpleKeyingInterfaceImpl< CBC_MAC_Base, CBC_MAC< T > >, CBC_MAC< T > >
static std::string | StaticAlgorithmName ()
| The algorithm name.
Static Public Member Functions inherited from SameKeyLengthAs< T, IV_REQ, IV_L >
static size_t | StaticGetValidKeyLength (size_t keylength)
| Provides a valid key length for the algorithm provided by a static function.

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Static Public Attributes inherited from SameKeyLengthAs< T, IV_REQ, IV_L >
static const int | MIN_KEYLENGTH =T::MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant.
static const int | MAX_KEYLENGTH =T::MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant.
static const int | DEFAULT_KEYLENGTH =T::DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | IV_REQUIREMENT =IV_REQ
| The default IV requirements for the algorithm provided as a constant.
static const int | IV_LENGTH =IV_L
| The default initialization vector length for the algorithm provided as a constant.

## Detailed Description

template<class T>
class CBC_MAC< T >

CBC-MAC.

Template Parameters

  T | BlockCipherDocumentation derived class

CBC-MAC is compatible with FIPS 113. The MAC is secure only for fixed length messages. For variable length messages use CMAC or DMAC.

See also
  CBC-MAC

Since
  Crypto++ 3.1

Definition at line 43 of file cbcmac.h.

## Constructor & Destructor Documentation

## CBC_MAC() [1/2]

template<class T>

CBC_MAC< T >::CBC_MAC | ( |  | ) |

inline

Construct a CBC_MAC.

Definition at line 47 of file cbcmac.h.

## CBC_MAC() [2/2]

template<class T>

CBC_MAC< T >::CBC_MAC | ( | const byte * | key,
|  | size_t | length = SameKeyLengthAs<T>::DEFAULT_KEYLENGTH )

inline

Construct a CBC_MAC.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer

Definition at line 51 of file cbcmac.h.

## Member Function Documentation

## StaticAlgorithmName()

template<class T>

std::string CBC_MAC< T >::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 54 of file cbcmac.h.

The documentation for this class was generated from the following file:

- cbcmac.h